//+------------------------------------------------------------------+
//|                                                   PixelSetAA.mq5 |
//|                              Copyright  2015, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version   "1.0"
#property description "Demonstration of the methods of ""PixelSetAA"""
//--- show the window of input parameters when launching the script
#property script_show_inputs
#include <Canvas\Canvas.mqh>
//+------------------------------------------------------------------+
//| inputs                                                           |
//+------------------------------------------------------------------+
input color colr=clrRed;
input color clr_Line=clrBlue;
//--- variable width and height of the chart.
int   ChartWidth=-1;
int   ChartHeight=-1;
//---
uchar    alpha=20;               //alpha channel managing color transparency
int      split=50;               //split between canvas and edges of chart
int      can_width,can_height;   //width and height of the canvas
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnStart()
  {
   double   x1_,y1_,x2_,y2_; //coordinates
//--- width and height of the chart
   can_width=ChartWidthInPixels()-(split*2);
   can_height=ChartHeightInPixelsGet()-(split*2);
//---
   x1_=can_width/2-22;       y1_=can_height/2-10;
   x2_=can_width/2+22;       y2_=can_height/2+10;
   double X1,Y1,X2,Y2;
//--- COLOR_FORMAT_ARGB_NORMALIZE
   CCanvas canvas_;
   if(!canvas_.CreateBitmapLabel("canvas_",split,split,can_width,can_height,COLOR_FORMAT_ARGB_NORMALIZE))
     {
      Print("Error creating canvas: ",GetLastError());
      return(-1);
     }
   canvas_.Erase(ColorToARGB(clrWhite,255));
   X1=x1_;     Y1=y1_;
   X2=x1_+12;  Y2=y1_;
   for(int i=0;i<11;i++)
     {
      canvas_.PixelSetAA(X1,Y1,ColorToARGB(clr_Line,255)); //one coordinate with a fractional part
      canvas_.PixelSetAA(X2,Y2,ColorToARGB(clr_Line,255)); //two coordinates with a fractional part
      X1+=0.1;Y1+=3.0;
      X2+=0.1;Y2+=3.1;
     }
   canvas_.Update();
   Sleep(6000);
//--- finish
   canvas_.Destroy();
   return(0);
  }
//+------------------------------------------------------------------+
//| Chart property width                                             |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
//| Chart property height                                            |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
